<?php
namespace Neos\Flow\Persistence\Doctrine\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

class Version20170317224325 extends AbstractMigration
{

    /**
     * @return string
     */
    public function getDescription()
    {
        return 'Add file state table.';
    }

    /**
     * @param Schema $schema
     * @return void
     * @throws \Doctrine\DBAL\DBALException
     * @throws \Doctrine\DBAL\Migrations\AbortMigrationException
     */
    public function up(Schema $schema)
    {
        // this up() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on "mysql".');
        
        $this->addSql('CREATE TABLE dl_assetsync_domain_model_filestate (persistence_object_identifier VARCHAR(40) NOT NULL, resource VARCHAR(40) DEFAULT NULL, sourceidentifier VARCHAR(255) NOT NULL, sourcefileidentifier VARCHAR(255) NOT NULL, sourcefileidentifierhash VARCHAR(40) NOT NULL, sourcefiletime DATETIME NOT NULL, lastsynced DATETIME NOT NULL, UNIQUE INDEX UNIQ_227AD8ABC91F416 (resource), INDEX identifierindex (sourceFileIdentifierHash), PRIMARY KEY(persistence_object_identifier)) DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci ENGINE = InnoDB ENGINE = InnoDB');
        $this->addSql('ALTER TABLE dl_assetsync_domain_model_filestate ADD CONSTRAINT FK_227AD8ABC91F416 FOREIGN KEY (resource) REFERENCES neos_flow_resourcemanagement_persistentresource (persistence_object_identifier)');
    }

    /**
     * @param Schema $schema
     * @return void
     * @throws \Doctrine\DBAL\DBALException
     * @throws \Doctrine\DBAL\Migrations\AbortMigrationException
     */
    public function down(Schema $schema)
    {
        // this down() migration is autogenerated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() != 'mysql', 'Migration can only be executed safely on "mysql".');
        
        $this->addSql('DROP TABLE dl_assetsync_domain_model_filestate');
    }
}
